/**********************************************************************
**  Copyright 2003 Steve Essery (tecknobabble@hotmail.com)
**
**  This file is part of the TaskList Applet.
**
**  The TaskList Applet is free software; you can redistribute it
**  and/or modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2 of
**  the License, or (at your option) any later version.
**
**  The TaskList Applet is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with the TaskList Applet; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
**********************************************************************/

#ifndef CUSTOM_MENU_WIDGET_H
#define CUSTOM_MENU_WIDGET_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qlayout.h>
#include <qguardedptr.h>
#include "simplebutton.h"


class CustomMenuWidget : public QWidget
{
    Q_OBJECT
public:
    enum CustomStyle { IconOnly    = 0x1,
                       TextOnly    = 0x2,
		       TextAndIcon = 0x3 };

    CustomMenuWidget(QPixmap &icon, int i, bool cf, bool ex=true,
                     QWidget *parent=0, const char *name=0);

    CustomMenuWidget(QString &text, int i, bool cf, bool ex=true,
                     QWidget *parent=0, const char *name=0);

    CustomMenuWidget(QPixmap &icon, QString &text, int i, bool cf, bool ex=true,
                     QWidget *parent=0, const char *name=0);

   ~CustomMenuWidget();

    CustomStyle customStyle ();
    void setId(int i);

signals:
    void raisePicked(int);
    void cancelPicked(int);

private slots:
    void raiseClicked();
    void cancelClicked();

protected:
    void createLabel();

private:

    int id;
    bool showCancel;
    bool expandItem;
    CustomStyle   style;
    QHBoxLayout  *layout;
    SimpleButton *itemButton;
    SimpleButton *cancelButton;
    QPixmap      *labelPixmap;
    QString       itemText;
    QPixmap       itemPixmap;
    QPixmap       cancelPixmap;
};

#endif
