/**********************************************************************
**  Copyright 2003 Steve Essery (tecknobabble@hotmail.com)
**
**  This file is part of the TaskList Applet.
**
**  The TaskList Applet is free software; you can redistribute it
**  and/or modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2 of
**  the License, or (at your option) any later version.
**
**  The TaskList Applet is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with the TaskList Applet; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
**********************************************************************/

#include "tasklist.h"
#include "tasklistappletimpl.h"

#include <stdio.h>

TaskListAppletImpl::TaskListAppletImpl()
    : tasklist(0), ref(0)
{
    printf("TaskListAppletImpl::TaskListAppletImpl()\n");
}

TaskListAppletImpl::~TaskListAppletImpl()
{
    delete tasklist;
}

QWidget *TaskListAppletImpl::applet( QWidget *parent )
{
    printf("TaskListAppletImpl::applet()\n");
    if ( !tasklist )
	tasklist = new TaskListApplet( parent );
    return tasklist;
}

int TaskListAppletImpl::position() const
{
    printf("TaskListAppletImpl::position()\n");
    return 7;
}

QRESULT TaskListAppletImpl::queryInterface( const QUuid &uuid, QUnknownInterface **iface )
{
    printf("TaskListAppletImpl::queryInterface()\n");
    *iface = 0;
    if ( uuid == IID_QUnknown )
	*iface = this;
    else if ( uuid == IID_TaskbarApplet )
	*iface = this;
    else
	return QS_FALSE;

    (*iface)->addRef();
    return QS_OK;
}

Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE( TaskListAppletImpl )
}


